﻿Type=Class
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
'Events declaration
#Event: Result( col As Int, res() As Int)
Sub Class_Globals
	Private closebtn As Button
	Private cnvs As Canvas
	Private cx, cy, r1, r2 As Float
	Private selectedcolor As Int 
	Private colorbtn As  Button 'Label
	Private mymodule As Object
	Private backpnl, basepnl, palette, pltcursor As Panel
	Private myname As String
	
End Sub

'Initializes the object. 
Public Sub Initialize(Parent As activity, Module As Object, Eventname As String, Background As Int)
mymodule = Module
myname = Eventname

Dim CF As Double =  Sqrt((100%y * 100%y + 100%x * 100%x)/(Power(430 * Density,2) + Power(800 * Density,2))) 

backpnl.Initialize("backpnl")
Parent.AddView(backpnl,0,0,100%x,100%y)
backpnl.Color = Colors.Black

basepnl.Initialize("")
basepnl.color = Background

palette.Initialize("palette")

pltcursor.Initialize("")
pltcursor.SetBackgroundImage(LoadBitmap(File.DirAssets,"cursor.png"))

Dim dr As ColorDrawable
dr.Initialize2(Colors.LightGray,1%x,0.5%x,Colors.black)
closebtn.Initialize("closebtn")
closebtn.Background = dr
closebtn.Typeface = Typeface.DEFAULT_BOLD
closebtn.Text = "X"
closebtn.TextColor = Colors.black
closebtn.TextSize = 20 * CF

selectedcolor = Colors.RGB(50,50,255)
dr.Initialize2(selectedcolor,1%x,0.5%x,Colors.black)
colorbtn.Initialize("colorbtn")
colorbtn.Background = dr
colorbtn.text = "V"
colorbtn.Typeface = Typeface.DEFAULT_BOLD
colorbtn.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.CENTER_HORIZONTAL)
colorbtn.textsize = 20 * CF

Dim bmp As Bitmap
bmp.Initialize(File.DirAssets,"RPC.png")
Dim rect0,rect1 As Rect
rect0.Initialize(0,0,bmp.Width,bmp.Height)

If Parent.Width < Parent.Height Then
	backpnl.AddView(basepnl,10%x,10%y,80%x,95%x)
	basepnl.AddView(palette,0,0,80%x,80%x)
	cx = 40%x
	cy = 40%x
	r1 = 30%x
	r2 = 40%x
	basepnl.AddView(pltcursor,cx-15%x,cy+7%x,2%x,2%x)
	rect1.Initialize(10%x,10%x,70%x,70%x)
	basepnl.AddView(colorbtn,5%x,80%x,20%x,11%x)
	basepnl.AddView(closebtn,55%x,80%x,20%x,11%x)
Else
	backpnl.AddView(basepnl,50%x-40%y,0,80%y,95%y)
	basepnl.AddView(palette,0,0,80%y,80%y)
	cx = 40%y
	cy = 40%y
	r1 = 30%y
	r2 = 40%y
	basepnl.AddView(pltcursor,cx-15%y,cy+7%y,2%y,2%y)
	rect1.Initialize(10%y,10%y,70%y,70%y)
	basepnl.AddView(colorbtn,5%y,80%y,20%y,11%y)
	basepnl.AddView(closebtn,55%y,80%y,20%y,11%y)
End If
cnvs.Initialize(palette)
cnvs.DrawBitmap(bmp,rect0,rect1)
backpnl.Visible = False

End Sub

Public Sub AsView As View
Return backpnl
End Sub

Private Sub drawlum  
Dim res() As Int 
res = ParseColor(selectedcolor)
Dim col As Int
Dim delR1,delG1,delB1,delR2,delG2,delB2 As Double
delR1 = (255-res(1))/360
delG1 = (255-res(2))/360
delB1 = (255-res(3))/360
delR2 = res(1)/360
delG2 = res(2)/360
delB2 = res(3)/360
For i = 0 To 360
	col = Colors.RGB(255-i * delR1,255- i*delG1,255- i*delB1)
	cnvs.DrawLine(cx+r1*SinD(i/2),cy-r1*CosD(i/2),cx+r2*SinD(i/2),cy-r2*CosD(i/2),col,4)
	col = Colors.RGB(i * delR2, i*delG2,i*delB2)
	cnvs.DrawLine(cx+r1*SinD(-i/2),cy-r1*CosD(-i/2),cx+r2*SinD(-i/2),cy-r2*CosD(-i/2),col,4)
Next
palette.Invalidate
End Sub

Private Sub ParseColor(clr As Int) As Int()
Dim res(4) As Int
res(0) = Bit.UnsignedShiftRight(Bit.AND(clr, 0xff000000), 24) ' alfa
res(1) = Bit.UnsignedShiftRight(Bit.AND(clr, 0xff0000), 16)   ' R
res(2) = Bit.UnsignedShiftRight(Bit.AND(clr, 0xff00), 8)      ' G
res(3) = Bit.AND(clr, 0xff)  ' B
Return res
End Sub

'Shows the palette and enables coosing the color. 
'Ruturns the color as Int and As A,R,G,B In Sub Eventname_Result In the calling module.
Public Sub GetColor 
drawlum
backpnl.Visible = True
End Sub

Private Sub colorbtn_click
backpnl.Visible = False
CallSub3(mymodule, myname & "_Result", selectedcolor, ParseColor(selectedcolor))
End Sub

Private Sub closebtn_click
backpnl.Visible = False
End Sub

Private Sub palette_Touch (Action As Int, X As Float, Y As Float)
Dim res(4) As Int
Dim clr As Int = cnvs.Bitmap.GetPixel(X,Y)

res(1) = Bit.UnsignedShiftRight(Bit.AND(clr, 0xff0000), 16)   ' R
res(2) = Bit.UnsignedShiftRight(Bit.AND(clr, 0xff00), 8)      ' G
res(3) = Bit.AND(clr, 0xff)                                   ' B
selectedcolor = clr
If Sqrt((cx-X)*(cx-X)+(cy-Y)*(cy-Y)) < r1 Then  drawlum
Dim dr As ColorDrawable


If (res(1)+res(2)+res(3)) > 240 Then 
	colorbtn.TextColor = Colors.Black
	dr.Initialize2(selectedcolor,1%x,0.5%x,Colors.black)
Else
	colorbtn.TextColor = Colors.white
	dr.Initialize2(selectedcolor,1%x,0.5%x,Colors.white)
End If
colorbtn.Background = dr
pltcursor.SetLayout(X-pltcursor.Width/2,Y-pltcursor.Height/2,pltcursor.Width,pltcursor.height)
End Sub

Private Sub  backpnl_Touch (Action As Int, X As Float, Y As Float)
End Sub
